using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace VCD_Simple_Property
{
    public partial class Form1 : Form
    {

        private TIS.Imaging.VCDSwitchProperty _brightnessAuto;
        private TIS.Imaging.VCDSwitchProperty _whitebalanceAuto;
        private TIS.Imaging.VCDRangeProperty _brightnessRange;
        private TIS.Imaging.VCDRangeProperty _whitebalanceBlueRange;
        private TIS.Imaging.VCDRangeProperty _whitebalanceRedRange;
        private TIS.Imaging.VCDRangeProperty _whitebalanceGreenRange;

        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load( object sender, EventArgs e )
        {

            if( !icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml") )
            {
                MessageBox.Show("No device was selected.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
                return;
            }


            //Jo͂ꂽfIC Imaging Contorol̃Rg[\TCYɂ
            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveDisplaySize = icImagingControl1.Size;


            //邳̐ݒ
            _brightnessAuto = icImagingControl1.VCDPropertyItems.Find<VCDSwitchProperty>( VCDGUIDs.VCDID_Brightness, VCDGUIDs.VCDElement_Auto );
            if( _brightnessAuto == null )
            {
                BrightnessAutoCheckBox.Enabled = false;
            }
            else
            {
                _brightnessAuto.Switch = false;
            }

            //邳̐ݒ
            _brightnessRange = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>( VCDGUIDs.VCDID_Brightness, VCDGUIDs.VCDElement_Value );
            if( _brightnessRange == null )
            {
                BrightnessTrackBar.Enabled = false;
            }
            else
            {
                BrightnessTrackBar.Enabled = true;
                BrightnessTrackBar.Minimum = _brightnessRange.RangeMin;
                BrightnessTrackBar.Maximum = _brightnessRange.RangeMax;
                BrightnessTrackBar.Value = _brightnessRange.Value;
                BrightnessTrackBar.TickFrequency = (BrightnessTrackBar.Maximum - BrightnessTrackBar.Minimum) / 10;
                BrightnessValueLabel.Text = BrightnessTrackBar.Value.ToString();
            }

            //zCgoX̐ݒ
            _whitebalanceAuto = icImagingControl1.VCDPropertyItems.Find<VCDSwitchProperty>(VCDGUIDs.VCDID_WhiteBalance, VCDGUIDs.VCDElement_Auto);
            if (_whitebalanceAuto == null)
            {
                WhitebalanceCheckBox.Enabled = false;
                WhitebalanceOnePushButton.Enabled = false;
            }
            else
            {
                _whitebalanceAuto.Switch = false;
            }

            //zCgoX@̐ݒ
            _whitebalanceBlueRange = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>( VCDGUIDs.VCDID_WhiteBalance, VCDGUIDs.VCDElement_WhiteBalanceBlue );
            if( _whitebalanceBlueRange == null )
            {
                WhiteBalBlueTrackBar.Enabled = false;
            }
            else
            {
                WhiteBalBlueTrackBar.Enabled = true;
                WhiteBalBlueTrackBar.Minimum = _whitebalanceBlueRange.RangeMin;
                WhiteBalBlueTrackBar.Maximum = _whitebalanceBlueRange.RangeMax;
                WhiteBalBlueTrackBar.Value = _whitebalanceBlueRange.Value;
                WhiteBalBlueTrackBar.TickFrequency = (WhiteBalBlueTrackBar.Maximum - WhiteBalBlueTrackBar.Minimum) / 10;
                WhiteBalBlueLabel.Text = WhiteBalBlueTrackBar.Value.ToString();
            }

            //zCgoX@Ԃ̐ݒ
            _whitebalanceRedRange = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>( VCDGUIDs.VCDID_WhiteBalance, VCDGUIDs.VCDElement_WhiteBalanceRed );
            if( _whitebalanceRedRange == null )
            {
                WhiteBalRedTrackBar.Enabled = false;
            }
            else
            {
                WhiteBalRedTrackBar.Enabled = false;
                WhiteBalRedTrackBar.Enabled = true;
                WhiteBalRedTrackBar.Minimum = _whitebalanceRedRange.RangeMin;
                WhiteBalRedTrackBar.Maximum = _whitebalanceRedRange.RangeMax;
                WhiteBalRedTrackBar.Value = _whitebalanceRedRange.Value;
                WhiteBalRedTrackBar.TickFrequency = (WhiteBalRedTrackBar.Maximum - WhiteBalRedTrackBar.Minimum) / 10;
                WhiteBalRedLabel.Text = WhiteBalRedTrackBar.Value.ToString();
            }

            //zCgoX@΂̐ݒ
            _whitebalanceGreenRange = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_WhiteBalance, VCDGUIDs.VCDElement_WhiteBalanceGreen);
            if (_whitebalanceGreenRange == null)
            {
                WhiteBalGreenTrackBar.Enabled = false;
            }
            else
            {
                WhiteBalGreenTrackBar.Enabled = false;
                WhiteBalGreenTrackBar.Enabled = true;
                WhiteBalGreenTrackBar.Minimum = _whitebalanceGreenRange.RangeMin;
                WhiteBalGreenTrackBar.Maximum = _whitebalanceGreenRange.RangeMax;
                WhiteBalGreenTrackBar.Value = _whitebalanceGreenRange.Value;
                WhiteBalGreenTrackBar.TickFrequency = (WhiteBalGreenTrackBar.Maximum - WhiteBalGreenTrackBar.Minimum) / 10;
                WhiteBalGreenLabel.Text = WhiteBalGreenTrackBar.Value.ToString();
            }

            // CuXg[~OJn
            icImagingControl1.LiveStart();
        }

        private void BrightnessAutoCheckBox_CheckedChanged( object sender, EventArgs e )
        {
            _brightnessAuto.Switch = BrightnessAutoCheckBox.Checked;
            BrightnessTrackBar.Enabled = !BrightnessAutoCheckBox.Checked;
        }
        private void BrightnessTrackBar_Scroll(object sender, EventArgs e)
        {
            _brightnessRange.Value = BrightnessTrackBar.Value;
            BrightnessValueLabel.Text = _brightnessRange.Value.ToString();
        }

        private void WhitebalanceCheckBox_CheckedChanged( object sender, EventArgs e )
        {
            _whitebalanceAuto.Switch = WhitebalanceCheckBox.Checked;
            WhiteBalBlueTrackBar.Enabled = !WhitebalanceCheckBox.Checked;
            WhiteBalRedTrackBar.Enabled = !WhitebalanceCheckBox.Checked;
            WhiteBalGreenTrackBar.Enabled = !WhitebalanceCheckBox.Checked;

            WhiteBalBlueTrackBar.Value = _whitebalanceBlueRange.Value;
            WhiteBalRedTrackBar.Value = _whitebalanceRedRange.Value;
            WhiteBalGreenTrackBar.Value = _whitebalanceGreenRange.Value;
        }


        private void WhiteBalRedTrackBar_Scroll( object sender, EventArgs e )
        {
            _whitebalanceRedRange.Value = WhiteBalRedTrackBar.Value;
            WhiteBalRedLabel.Text = _whitebalanceRedRange.Value.ToString();
        }

        private void WhiteBalBlueTrackBar_Scroll( object sender, EventArgs e )
        {
            _whitebalanceBlueRange.Value = WhiteBalBlueTrackBar.Value;
            WhiteBalBlueLabel.Text = _whitebalanceBlueRange.Value.ToString();
        }

        private void WhiteBalGreenTrackBar_Scroll(object sender, EventArgs e)
        {
            _whitebalanceGreenRange.Value = WhiteBalGreenTrackBar.Value;
            WhiteBalGreenLabel.Text = _whitebalanceGreenRange.Value.ToString();
        }

        private void WhitebalanceOnePushButton_Click( object sender, EventArgs e )
        {
            var whiteBalanceOnePush = icImagingControl1.VCDPropertyItems.Find<VCDButtonProperty>( VCDGUIDs.VCDID_WhiteBalance, VCDGUIDs.VCDElement_OnePush );
            if( whiteBalanceOnePush != null )
            {
                whiteBalanceOnePush.Push();
                WhiteBalBlueTrackBar.Value = _whitebalanceBlueRange.Value;
                WhiteBalRedTrackBar.Value = _whitebalanceRedRange.Value;
                WhiteBalGreenTrackBar.Value = _whitebalanceGreenRange.Value;

            }
        }




    }
}